#include "Archive.h"
#include "ColouredPlane.h"

bool Archive::Member::isSameAs(Member &other) {
    return invariant == other.invariant &&
           *getCanonicalForm() == *(other.getCanonicalForm());
}

const SparseGraph *Archive::Member::getCanonicalForm() {
    if (!canonicalForm) {
        canonicalForm = ColouredPlane(set).canonicalForm();
    }
    return canonicalForm;
}

bool Archive::add(PointSet &set, int invariant, SparseGraph *canonicalForm) {
    Member other(set, invariant, canonicalForm);
    for (Member &member : members) {
        if (other.isSameAs(member)) {
            other.clear();
            return false;
        }
    }
    members.emplace_back(other); // emplace_back avoids one copy?
    return true;
}
