#include "PointSet.h"
#include "SparseGraph.h"

void PointSet::add(int pt) {
    present[pt] = true;
    size++;
    // TODO additional data needs to be store
}

void PointSet::remove(int pt) {
    // undo what was done in add
    size--;
    present[pt] = false;
}

void PointSet::print() const {
    for (int pt = 0; pt < V; pt++) {
        if (present[pt]) {
            printf("%d-", pt);
        }
    }
    putchar('\n');
}

bool PointSet::operator==(const PointSet &other) const {
    // optimization by first looking at size is not useful because only
    // sets of the same size will be compared
    // if (size != other.size) {
    //   return false;
    // }
    for (int pt = 0; pt < V; pt++) {
        if (present[pt] != other.present[pt]) {
            return false;
        }
    }
    return true;
}

bool PointSet::operator!=(const PointSet &other) const {
    // comments: see operator==
    for (int pt = 0; pt < V; pt++) {
        if (present[pt] != other.present[pt]) {
            return true;
        }
    }
    return false;
}


