#ifndef BSETSALT_POINTSET_H
#define BSETSALT_POINTSET_H

#include <array>
#include "options.h"
#include "SparseGraph.h"

class PointSet {

private:
    // is point i present in this set?
    std::array<bool, V> present {false, };

    // size of the set currently being generated
    int size = 0;

public:

    // Add a point. Should only be called when the point is not already in the set.
    void add(int pt);

    // Remove a point that was previously added. Should only be called when the point is already in the set. This is not checked.
    void remove(int pt);

    // Does this set contain the given point?
    bool contains(int pt) const { return present[pt]; }

    // How many points does this set contain?
    int getSize () const { return size; }

    // print a representation of this set to stdout
    void print() const;

    // set equality
    bool operator==(const PointSet &other) const;
    bool operator!=(const PointSet &other) const;

};


#endif //BSETSALT_POINTSET_H
