#ifndef BSETSALT_SPARSEGRAPH_H
#define BSETSALT_SPARSEGRAPH_H

#include <nausparse.h>

/**
 * Wraps a Nauty sparse graph into a C++ class. Allocates memory for the edge and degrees arrays.
 */
class SparseGraph : public sparsegraph {

public:

    /**
     * Create a sparse graph with the given nr of vertices and (directed) edges. Not initialized.
     */
    SparseGraph(int nrOfVertices, int nrOfDirectedEdges);

    /**
     * Create the sparse graph that corresponds to the plane of given order and difference set.
     */
    SparseGraph (int q, const int dset[]);

    /**
     * Removes heap allocated memory
     */
    ~SparseGraph();

    // Do these represent the same graph?
    bool operator==( const SparseGraph &other) const;

    bool operator!=( const SparseGraph &other) const;
};

#endif //BSETSALT_SPARSEGRAPH_H